DefaultServlet (Java Card API, Connected Edition)
Date: 2009-12-11

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javacardx.servlet.http
Class DefaultServlet

    java.lang.Object
      javax.servlet.GenericServlet
          javax.servlet.http.HttpServlet
              javacardx.servlet.http.DefaultServlet

All Implemented Interfaces:
  Servlet, ServletConfig

    @TransactionType(value=NOT_SUPPORTED)
    public class DefaultServlet

extends HttpServlet

This class is the default Default Servlet that implements the default container behavior and which is mapped to the ”/” URL pattern.

This class may be used to redeclare the mapping of the default servlet in a web application deployment descriptor in order to define security constraints or filters for static content served as per the default container behavior. For example, the mapping of the default servlet may be redeclared as follows:

     <servlet>
        <description>default servlet</description>
        <servlet-name>default</servlet-name>
        <servlet-class>javacardx.servlet.http.DefaultServlet</servlet-class>
     </servlet>
     <servlet-mapping>
        <servlet-name>default</servlet-name>
        <url-pattern><i>path</i></url-pattern>
     </servlet-mapping>

path may be a specific path to an application's static content or it may be '/' and may, therefore, designate all that application's static content.

The default Default Servlet implements the following behavior:

- it serves static resources requested via HTTP GET or HEAD requests.
- it rejects HTTP TRACE or OPTIONS requests and returns an HTTP status 501 (Not implemented).
- it denies HTTP POST, DELETE or PUT requests and returns an HTTP status 403 (Forbidden).
- it does not produce directory listings when no welcome file matches a request and returns an HTTP status 404 (Not found) instead.

See Runtime Environment Specification for the Java Card Platform, Connected Edition, chapter 3 for details regarding the default container behavior.

Constructor Summary
`DefaultServlet()`

Method Summary
`void` | `destroy()` Called by the servlet container to indicate to a servlet that the servlet is being taken out of service.
`protected void` | `doDelete(HttpServletRequest req, HttpServletResponse resp)` By default, responds with an HTTP status 403 (Forbidden).
`protected void` | `doGet(HttpServletRequest req, HttpServletResponse resp)` By default, services static resources requested through a HTTP GET method.
`protected void` | `doHead(HttpServletRequest req, HttpServletResponse resp)` By default, services HTTP HEAD requets on static resource.
`protected void` | `doOptions(HttpServletRequest req, HttpServletResponse resp)` By default, responds with an HTTP status 501 (Not implemented).
`protected void` | `doPost(HttpServletRequest req, HttpServletResponse resp)` By default, responds with an HTTP status 403 (Forbidden).
`protected void` | `doPut(HttpServletRequest req, HttpServletResponse resp)` By default, responds with an HTTP status 403 (Forbidden).
`protected void` | `doTrace(HttpServletRequest req, HttpServletResponse resp)` By default, responds with an HTTP status 501 (Not implemented).
`protected long` | `getLastModified(HttpServletRequest req)` Returns the time the `HttpServletRequest` object was last modified, in milliseconds since midnight January 1, 1970 GMT.
`String` | `getServletInfo()` Returns information about the servlet, such as author, version, and copyright.
`void` | `init()` A convenience method which can be overridden so that there's no need to call `super.init(config)`.
`void` | `init(ServletConfig config)` Called by the servlet container to indicate to a servlet that the servlet is being placed into service.
`protected void` | `service(HttpServletRequest req, HttpServletResponse resp)` Receives standard HTTP requests from the public `service` method and dispatches them to the `do`XXX methods defined in this class.
`void` | `service(ServletRequest req, ServletResponse res)` Dispatches client requests to the protected `service` method.

Methods inherited from class javax.servlet.GenericServlet
`getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletName, log, log`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DefaultServlet

    public DefaultServlet()

Method Detail

### destroy

    public void destroy()

  Called by the servlet container to indicate to a servlet that the servlet is being taken out of service. See `Servlet.destroy()`.

  Specified by:
    `destroy` in interface `Servlet`
  Overrides:
    `destroy` in class `GenericServlet`

### doDelete

    protected void doDelete(HttpServletRequest req,
                            HttpServletResponse resp)
                     throws ServletException,
                            IOException

  By default, responds with an HTTP status 403 (Forbidden). Called by the server (via the `service` method) to allow a servlet to handle a DELETE request. The DELETE operation allows a client to remove a document or Web page from the server.

  This method does not need to be either safe or idempotent. Operations requested through DELETE can have side effects for which users can be held accountable. When using this method, it may be useful to save a copy of the affected URL in temporary storage.

  If the HTTP DELETE request is incorrectly formatted, `doDelete` returns an HTTP "Bad Request" message.

  Overrides:
    `doDelete` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that contains the request the client made of the servlet
    `resp` - the `HttpServletResponse` object that contains the response the servlet returns to the client
  Throws:
    `ServletException` - if the request for the DELETE cannot be handled
    `IOException` - if an input or output error occurs while the servlet is handling the DELETE request

### doGet

    protected void doGet(HttpServletRequest req,
                         HttpServletResponse resp)
                  throws ServletException,
                         IOException

  By default, services static resources requested through a HTTP GET method. If the static resource corresponds to a directory and no welcome file matches, responds with an HTTP status 404 (Not found); no directory listings is retuned. Called by the server (via the `service` method) to allow a servlet to handle a GET request.

  Overriding this method to support a GET request also automatically supports an HTTP HEAD request. A HEAD request is a GET request that returns no body in the response, only the request header fields.

  When overriding this method, read the request data, write the response headers, get the response's writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

  The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

  Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

  When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

  The GET method should be safe, that is, without any side effects for which users are held responsible. For example, most form queries have no side effects. If a client request is intended to change stored data, the request should use some other HTTP method.

  The GET method should also be idempotent, meaning that it can be safely repeated. Sometimes making a method safe also makes it idempotent. For example, repeating queries is both safe and idempotent, but buying a product online or modifying data is neither safe nor idempotent.

  If the request is incorrectly formatted, `doGet` returns an HTTP "Bad Request" message.

  Overrides:
    `doGet` in class `HttpServlet`
  Parameters:
    `req` - an `HttpServletRequest` object that contains the request the client has made of the servlet
    `resp` - an `HttpServletResponse` object that contains the response the servlet sends to the client
  Throws:
    `ServletException` - if the request for the GET could not be handled
    `IOException` - if an input or output error is detected when the servlet handles the GET request
  See Also:
    `ServletResponse.setContentType(java.lang.String)`

### doHead

    protected void doHead(HttpServletRequest req,
                          HttpServletResponse resp)
                   throws ServletException,
                          IOException

  By default, services HTTP HEAD requets on static resource. If the static resource corresponds to a directory and no welcome file matches, responds with an HTTP status 404 (Not found).

  Receives an HTTP HEAD request from the protected `service` method and handles the request. The client sends a HEAD request when it wants to see only the headers of a response, such as Content-Type or Content-Length. The HTTP HEAD method counts the output bytes in the response to set the Content-Length header accurately.

  If you override this method, you can avoid computing the response body and just set the response headers directly to improve performance. Make sure that the `doHead` method you write is both safe and idempotent (that is, protects itself from being called multiple times for one HTTP HEAD request).

  If the HTTP HEAD request is incorrectly formatted, `doHead` returns an HTTP "Bad Request" message.

  Overrides:
    `doHead` in class `HttpServlet`
  Parameters:
    `req` - the request object that is passed to the servlet
    `resp` - the response object that the servlet uses to return the headers to the clien
  Throws:
    `ServletException` - if the request for the HEAD could not be handled
    `IOException` - if an input or output error occurs

### doOptions

    protected void doOptions(HttpServletRequest req,
                             HttpServletResponse resp)
                      throws ServletException,
                             IOException

  By default, responds with an HTTP status 501 (Not implemented). Called by the server (via the `service` method) to allow a servlet to handle a OPTIONS request. The OPTIONS request determines which HTTP methods the server supports and returns an appropriate header. For example, if a servlet overrides `doGet`, this method may be overridden to return the following header:

  `Allow: GET, HEAD, OPTIONS`

  By default, this method respond with an HTTP status code 501 (Not implemented). This method must be overridden when support for this feature is required.

  Overrides:
    `doOptions` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that contains the request the client made of the servlet
    `resp` - the `HttpServletResponse` object that contains the response the servlet returns to the client
  Throws:
    `ServletException` - if the request for the OPTIONS cannot be handled
    `IOException` - if an input or output error occurs while the servlet is handling the OPTIONS request

### doPost

    protected void doPost(HttpServletRequest req,
                          HttpServletResponse resp)
                   throws ServletException,
                          IOException

  By default, responds with an HTTP status 403 (Forbidden). Called by the server (via the `service` method) to allow a servlet to handle a POST request. The HTTP POST method allows the client to send data of unlimited length to the Web server a single time and is useful when posting information such as credit card numbers.

  When overriding this method, read the request data, write the response headers, get the response's writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

  The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

  Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

  When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

  This method does not need to be either safe or idempotent. Operations requested through POST can have side effects for which the user can be held accountable, for example, updating stored data or buying items online.

  If the HTTP POST request is incorrectly formatted, `doPost` returns an HTTP "Bad Request" message.

  Overrides:
    `doPost` in class `HttpServlet`
  Parameters:
    `req` - an `HttpServletRequest` object that contains the request the client has made of the servlet
    `resp` - an `HttpServletResponse` object that contains the response the servlet sends to the client
  Throws:
    `ServletException` - if the request for the POST could not be handled
    `IOException` - if an input or output error is detected when the servlet handles the request
  See Also:
    `ServletOutputStream`, `ServletResponse.setContentType(java.lang.String)`

### doPut

    protected void doPut(HttpServletRequest req,
                         HttpServletResponse resp)
                  throws ServletException,
                         IOException

  By default, responds with an HTTP status 403 (Forbidden). Called by the server (via the `service` method) to allow a servlet to handle a PUT request. The PUT operation allows a client to place a file on the server and is similar to sending a file by FTP.

  When overriding this method, leave intact any content headers sent with the request (including Content-Length, Content-Type, Content-Transfer-Encoding, Content-Encoding, Content-Base, Content-Language, Content-Location, Content-MD5, and Content-Range). If your method cannot handle a content header, it must issue an error message (HTTP 501 - Not Implemented) and discard the request. For more information on HTTP 1.1, see RFC 2616 .

  This method does not need to be either safe or idempotent. Operations that `doPut` performs can have side effects for which the user can be held accountable. When using this method, it may be useful to save a copy of the affected URL in temporary storage.

  If the HTTP PUT request is incorrectly formatted, `doPut` returns an HTTP "Bad Request" message.

  Overrides:
    `doPut` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that contains the request the client made of the servlet
    `resp` - the `HttpServletResponse` object that contains the response the servlet returns to the client
  Throws:
    `ServletException` - if the request for the PUT cannot be handled
    `IOException` - if an input or output error occurs while the servlet is handling the PUT request

### doTrace

    protected void doTrace(HttpServletRequest req,
                           HttpServletResponse resp)
                    throws ServletException,
                           IOException

  By default, responds with an HTTP status 501 (Not implemented). Called by the server (via the `service` method) to allow a servlet to handle a TRACE request. A TRACE should return the headers sent with the TRACE request to the client, so that they can be used in debugging.

  By default, this method respond with an HTTP status code 501 (Not implemented). This method must be overridden when support for this feature is required.

  Overrides:
    `doTrace` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that contains the request the client made of the servlet
    `resp` - the `HttpServletResponse` object that contains the response the servlet returns to the client
  Throws:
    `ServletException` - if the request for the TRACE cannot be handled
    `IOException` - if an input or output error occurs while the servlet is handling the TRACE request

### getLastModified

    protected long getLastModified(HttpServletRequest req)

  Returns the time the `HttpServletRequest` object was last modified, in milliseconds since midnight January 1, 1970 GMT. If the time is unknown, this method returns a negative number (the default).

  Servlets that support HTTP GET requests and can quickly determine their last modification time should override this method. This makes browser and proxy caches work more effectively, reducing the load on server and network resources.

  Overrides:
    `getLastModified` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that is sent to the servlet
  Returns:
    a `long` integer specifying the time the `HttpServletRequest` object was last modified, in milliseconds since midnight, January 1, 1970 GMT, or -1 if the time is not known

### getServletInfo

    public String getServletInfo()

  Returns information about the servlet, such as author, version, and copyright. By default, this method returns an empty string. Override this method to have it return a meaningful value. See `Servlet.getServletInfo()`.

  Specified by:
    `getServletInfo` in interface `Servlet`
  Overrides:
    `getServletInfo` in class `GenericServlet`
  Returns:
    String information about this servlet, by default an empty string

### init

    public void init()
              throws ServletException

  A convenience method which can be overridden so that there's no need to call `super.init(config)`.

  Instead of overriding `GenericServlet.init(ServletConfig)`, simply override this method and it will be called by `GenericServlet.init(ServletConfig config)`. The `ServletConfig` object can still be retrieved via `GenericServlet.getServletConfig()`.

  Overrides:
    `init` in class `GenericServlet`
  Throws:
    `ServletException` - if an exception occurs that interrupts the servlet's normal operation

### init

    public void init(ServletConfig config)
              throws ServletException

  Called by the servlet container to indicate to a servlet that the servlet is being placed into service. See `Servlet.init(javax.servlet.ServletConfig)`.

  This implementation stores the `ServletConfig` object it receives from the servlet container for later use. When overriding this form of the method, call `super.init(config)`.

  Specified by:
    `init` in interface `Servlet`
  Overrides:
    `init` in class `GenericServlet`
  Parameters:
    `config` - the `ServletConfig` object that contains configuration information for this servlet
  Throws:
    `ServletException` - if an exception occurs that interrupts the servlet's normal operation
  See Also:
    `UnavailableException`

### service

    protected void service(HttpServletRequest req,
                           HttpServletResponse resp)
                    throws ServletException,
                           IOException

  Receives standard HTTP requests from the public `service` method and dispatches them to the `do`XXX methods defined in this class. This method is an HTTP-specific version of the `Servlet.service(javax.servlet.ServletRequest, javax.servlet.ServletResponse)` method. There's no need to override this method.

  Overrides:
    `service` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that contains the request the client made of the servlet
    `resp` - the `HttpServletResponse` object that contains the response the servlet returns to the client
  Throws:
    `ServletException` - if the HTTP request cannot be handled
    `IOException` - if an input or output error occurs while the servlet is handling the HTTP request
  See Also:
    `Servlet.service(javax.servlet.ServletRequest, javax.servlet.ServletResponse)`

### service

    public void service(ServletRequest req,
                        ServletResponse res)
                 throws ServletException,
                        IOException

  Dispatches client requests to the protected `service` method. There's no need to override this method.

  Specified by:
    `service` in interface `Servlet`
  Overrides:
    `service` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that contains the request the client made of the servlet
    `res` - the `HttpServletResponse` object that contains the response the servlet returns to the client
  Throws:
    `ServletException` - if the HTTP request cannot be handled
    `IOException` - if an input or output error occurs while the servlet is handling the HTTP request
  See Also:
    `Servlet.service(javax.servlet.ServletRequest, javax.servlet.ServletResponse)`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2009 Sun Microsystems, Inc. All rights reserved.